// Copyright (C) 1999 Jean-Marc Valin

#ifndef VQTRAIN_H
#define VQTRAIN_H

#include "Node.h"
#include "ObjectRef.h"

class VQTrain : public Node {

protected:
   
   /**The ID of the 'output' output*/
   int outputID;

   /**The ID of the 'frames' input*/
   int framesInputID;

   /**Reference to the current object*/
   ObjectRef current;

   /**Number of means to train model*/
   int nbMeans;
   
   int processCount;

public:
   /**Constructor, takes the name of the node and a set of parameters*/
   VQTrain(string nodeName, ParameterSet params);

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

   /**Class reset routine.
      Each class will call its superclass reset() method*/
   virtual void reset();

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

protected:
   /**Default constructor, should not be used*/
   VQTrain() {throw new GeneralException("VQTrain copy constructor should not be called",__FILE__,__LINE__);}

};

#endif
