// Copyright (C) 1999 Dominic Letourneau

#ifndef _ANDNODE_H_
#define _ANDNODE_H_

#include "Node.h"
#include "Exception.h"
/** 
    The AND takes an unlimited number of inputs (bools) and returns the
    AND result.
    - INPUTS : unlimited (bools)
    - OUTPUTS: output (bool)
    @author Dominic Letourneau
    @version 1.0
 */
class AND : public Node {

public:

   ///Constructor, takes the name of the node and a set of parameters
   AND(string nodeName, ParameterSet params);

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

   void specificInitialize() {processCount=-1;Node::specificInitialize();}

   void reset() {processCount=-1;Node::reset();}


protected:

   int processCount;

   ///symbolic to numeric translation for input names
   virtual int translateInput(string inputName);

   ObjectRef output;

   ///Default constructor, should not be used
   AND() {throw(GeneralException("AND default constructor should not be called",__FILE__,__LINE__));}

};
#endif
