// Copyright (C) 1999 Dominic Letourneau

#ifndef _NETEXEC_H_
#define _NETEXEC_H_

#include "Node.h"

/** Instead of calling a function, this node calls an executable and
    pipe the output (stdout) into a string.
    @author Dominic Letourneau
    @version 1.0
*/
class NetExec : public Node {

public:

   /** The constructor with a nodeName and a parameter set */
   NetExec (string nodeName, ParameterSet params);

   /** The getOutput method overloaded from Node */
   virtual ObjectRef getOutput (int output_id, int count);
   
   void specificInitialize() {processCount=-1;Node::specificInitialize();}

   void reset() {processCount=-1;Node::reset();}
private:
   
   int processCount;

   /// The list output
   ObjectRef output;

   /// The status output
   ObjectRef status;
   
   /// CommandString
   int CmdInputID;

   /// Args
   int ArgsInputID;

   /// Status output
   int StatusOutID;

   /// String output
   int StringOutID;

   /// The default constructor
   NetExec() {
      throw new NodeException (NULL,"The default constructor should not be called from NetExec",__FILE__,__LINE__);
   }
};



#endif
